#!/home/professor/cjlin/software/python/bin/python

#!/usr/bin/env python

from os import system, popen
from string import find, split, atof
from math import log, floor, exp
from getopt import getopt
from sys import argv,exit
from svm import *

# svmtrain executable

# svmtrain = "~/bin/svm-train"

# default parameters

fold = 5
mem = 40

cexp_begin = -10
cexp_end = 10
cexp_step = 1

gexp_begin = -10
gexp_end = 10
gexp_step = 1

# process option

if len(argv) < 2:
	print "Usage: grid.py -c begin,end,step -g begin,end,step dataset"
	exit()

dataset = argv[-1]
argv = argv[:-1]
titlename = split(dataset,"/")[-1]
i = 1
while i < len(argv):
	if argv[i] == "-c":
		i = i + 1
		(cexp_begin,cexp_end,cexp_step) = map(atof,split(argv[i],","))
	elif argv[i] == "-g":
		i = i + 1
		(gexp_begin,gexp_end,gexp_step) = map(atof,split(argv[i],","))
	elif argv[i] == "-v":
		i = i + 1
		fold = argv[i]
	elif argv[i] == '-m':
		i = i + 1
		mem = argv[i]
	else:
		raise "Unknown option %s" % argv[i]
	i = i + 1

log_file = []
log_file0 = [titlename + '.L1.log', titlename + '.L2.log']
log_filesv = [titlename + '.L1.SV.log', titlename + '.L2.SV.log']
png_file = []
#for i in ['.L1.1', '.L1.3', '.L1.t', '.L2.RM', '.L2.t']:
#for i in ['.L1.2', '.L1.4', '.L1.t', '.L2.RM', '.L2.t']:
for i in ['.L1.2', '.L1.5', '.L1.t', '.L2.RM', '.L2.t']:
	log_file.append(titlename + i + '.log')
	png_file.append(titlename + i + '.png')

def gen_seq (begin,end,step):
	seq = []
	while 1:
		if step > 0 and begin > end: break
		if step < 0 and begin < end: break
		seq.append(begin)
		begin = begin + step
	return seq

gnuplots = []
for i in range(5):
	gnuplots.append(popen("gnuplot","w"))

def redraw (gnuplot,db,scale_type,cbound,tofile=0,filename=''):
	if len(db) == 0: return
#	begin_level = round(max(map(lambda(x):x[2],db))) - 1.5
#	step_size = 0.1
	if scale_type:
		step_size = .02
		end_level = .4
	else:
		step_size = round(min(map(lambda(x):x[2],db)) / 100) * 10
		if step_size < 20:
			step_size = 20
		end_level = step_size * 20
	if tofile:
		gnuplot.write("set term png small color\n")
		gnuplot.write("set output \"%s\"\n" % (filename))
	else:
		gnuplot.write("set term x11\n")
	gnuplot.write("set xlabel \"ln(C)\"\n")
	gnuplot.write("set ylabel \"ln(sigma^2)\"\n")
	gnuplot.write("set xrange [%s:%s]\n" % (cexp_begin,cexp_end))
	gnuplot.write("set yrange [%s:%s]\n" % (gexp_begin,gexp_end))
	gnuplot.write("set contour\n")
#	gnuplot.write("set cntrparam levels incremental %s,%s,100\n" % (begin_level,step_size))
	gnuplot.write("set cntrparam levels incremental 0, %s, %s\n" % (step_size, end_level))
# 	gnuplot.write("set cntrparam levels incremental 0, 0.2\n")
	gnuplot.write("set nosurface\n")
	gnuplot.write("set view 0,0\n")
	gnuplot.write("set label \"%s\" at screen 0.4,0.9\n" % (titlename))
	gnuplot.write("splot \"-\" with lines\n")
	def cmp (x,y):
		if x[0] < y[0]: return -1
		if x[0] > y[0]: return 1
		if x[1] > y[1]: return -1
		if x[1] < y[1]: return 1
		return 0
	db.sort(cmp)
	prevc = db[0][0]
	for line in db:
		if prevc != line[0]:
			gnuplot.write("\n")
			prevc = line[0]
#		if scale_type == 0 and cbound.has_key(float(line[1])) and cbound[float(line[1])] < line[0]:
		if cbound.has_key(float(line[1])) and cbound[float(line[1])] < line[0]:
			gnuplot.write("%s %s 999999999\n" % (line[0], line[1]))
		else:
			gnuplot.write("%s %s %s\n" % line)
#		gnuplot.write("%s %s %s\n" % (line[0], line[1], log(line[2])))
	gnuplot.write("e\n")
	gnuplot.flush()

cexp_seq = gen_seq(cexp_begin,cexp_end,cexp_step)
gexp_seq = gen_seq(gexp_begin,gexp_end,gexp_step)
cpass_total = floor(log(len(cexp_seq)) / log(2))
cpass_step = 0
gpass_total = floor(log(len(gexp_seq)) / log(2))
gpass_step = 0

cbounds = []
db = []
dbh0 = []
dbhsv = []
dbh = []
lf0 = []
lfsv = []
lf = []

def logmap0(l):
	t = map(float, l.split())
	return t[0], t[1], t[2], t[3], t[4]
for i in [0, 1]:
	open(log_file0[i], 'a').close()
	lf0.append(open(log_file0[i], 'r+'))
	dbh0.append({})
	for j in map(logmap0, lf0[i].readlines()):
		dbh0[i][(j[0], j[1])] = (j[2], j[3], j[4])

def logmapsv(l):
	t = map(float, l.split())
	return t[0], t[1], t[2], t[3]
for i in [0, 1]:
	open(log_filesv[i], 'a').close()
	lfsv.append(open(log_filesv[i], 'r+'))
	dbhsv.append({})
	cbounds.append({})
	for j in map(logmapsv, lfsv[i].readlines()):
		dbhsv[i][(j[0], j[1])] = (j[2], j[3])
		if i == 0 and j[2] - j[3] == 0 and (cbounds[i].has_key(j[1]) == 0 or cbounds[i][j[1]] > j[0]):
			cbounds[i][j[1]] = j[0]

def logmap(l):
	t = map(float, l.split())
	return t[0], t[1], t[2]
for i in range(5):
	open(log_file[i], 'a').close()
	lf.append(open(log_file[i], 'r+'))
	db.append(map(logmap, lf[i].readlines()))
	dbh.append({})
	for j in db[i]:
		dbh[i][(j[0], j[1])] = j[2]

def zerobits(x,y):
	i = int(x)
	if i == 0:
		return 2**(y-1)
	return i&(-i)

#bounds = [lambda wsq,cxi,rsq,c: rsq*(wsq+cxi)+cxi/c, lambda wsq,cxi,rsq,c: (rsq+1/c)*(wsq+2*cxi), lambda wsq,cxi,rsq,c: rsq*wsq]
#bounds = [lambda wsq,cxi,rsq,c: 4*rsq*(wsq+cxi)+cxi/c, lambda wsq,cxi,rsq,c: (rsq+0.5/c)*(wsq+2*cxi), lambda wsq,cxi,rsq,c: rsq*wsq]
bounds = [lambda wsq,cxi,rsq,c: 4*rsq*(wsq+cxi)+cxi/c, lambda wsq,cxi,rsq,c: (rsq+1/c)*(wsq+cxi), lambda wsq,cxi,rsq,c: rsq*wsq]
#param1 = svm_parameter(shrinking = 0)
#param2 = svm_parameter(svm_type = ONE_CLASS, shrinking = 0)
param = svm_parameter(eps = 0.000001)
fds = open("%(dataset)s" % globals(), 'r')
def mapdsy(l):
	return float(l.split()[0])
def mapdsx(l):
	e = l.split()[1:]
	x = {}
	for i in e:
		t = i.split(':')
		x[int(t[0])] = float(t[1])
	return x
ds = fds.readlines()
fds.close()
prob = svm_problem(y = map(mapdsy, ds), x = map(mapdsx, ds))
fds = open("%(dataset)s.t" % globals(), 'r')
ds = fds.readlines()
fds.close()
testx = map(mapdsx, ds)
testy = map(mapdsy, ds)

rate = [0, 0, 0, 0, 0]
def run():
	global cexp,gexp,c,g,db,dbh,dbh0,dbhsv,model
	cexp = cexp_seq[ci]				
	gexp = gexp_seq[gi]
# gexp's are actually \ln\sigma^2 now
	c = exp(cexp);
	g = 1 / (2 * exp(gexp))
	param.C = c
	param.gamma = g
	if dbh[0].has_key((float(cexp), float(gexp))) and dbh[1].has_key((float(cexp), float(gexp))) and dbh[2].has_key((float(cexp), float(gexp))) and dbhsv[0].has_key((float(cexp), float(gexp))):
		for i in range(3):
			rate[i] = dbh[i][(float(cexp), float(gexp))]
		nBSV = dbhsv[0][(float(cexp), float(gexp))][0] - dbhsv[0][(float(cexp), float(gexp))][1]
	else:
		if dbh0[0].has_key((float(cexp), float(gexp))) == 0 or dbh[2].has_key((float(cexp), float(gexp))) == 0 or dbhsv[0].has_key((float(cexp), float(gexp))) == 0:
			param.svm_type = R2
			model = svm_model(prob, param)
			rsq = model.rsq
			param.svm_type = C_SVC
			model = svm_model(prob, param)
			wsq = model.wsq
			cxi = model.cxi
			if dbh0[0].has_key((float(cexp), float(gexp))) == 0:
				lf0[0].write("%s %s %s %s %s\n" % (cexp, gexp, wsq, cxi, rsq))
				lf0[0].flush()
			for i in [0, 1]:
				rate[i] = bounds[i](wsq, cxi, rsq, c)
				if dbh[i].has_key((float(cexp), float(gexp))) == 0:
					db[i].append((cexp, gexp, rate[i]))
					dbh[i][(float(cexp), float(gexp))] = rate[i]
					lf[i].write("%s %s %s\n" % (cexp, gexp, rate[i]))
					lf[i].flush()
			if dbh[2].has_key((float(cexp), float(gexp))) == 0:
				error = 0;
				for i in range(len(testy)):
					resulty = model.predict(testx[i]);
					if resulty != testy[i]:
						error += 1;
				rate[2] = float(error) / float(len(testy))
				db[2].append((cexp, gexp, rate[2]))
				dbh[2][(float(cexp), float(gexp))] = rate[2]
				lf[2].write("%s %s %s\n" % (cexp, gexp, rate[2]))
				lf[2].flush()
			if dbhsv[0].has_key((float(cexp), float(gexp))) == 0:
				nSV = 0
				nBSV = 0
				for i in range(model.nr_class):
					nSV += model.nSV[i]
					nBSV += model.nBSV[i]
				lfsv[0].write("%s %s %s %s\n" % (cexp, gexp, nSV, nSV - nBSV))
				lfsv[0].flush()
		else:
			for i in [0, 1]:
				if dbh[i].has_key((float(cexp), float(gexp))) == 0:
					wsq, cxi, rsq = dbh0[0][(float(cexp), float(gexp))]
					rate[i] = bounds[i](wsq, cxi, rsq, c)
					db[i].append((cexp, gexp, rate[i]))
					dbh[i][(cexp, gexp)] = rate[i]
					lf[i].write("%s %s %s\n" % (cexp, gexp, rate[i]))
					lf[i].flush()
			nBSV = dbhsv[0][(float(cexp), float(gexp))][0] - dbhsv[0][(float(cexp), float(gexp))][1]
		print 'wsq = %s, cxi = %s, rsq = %s' % (wsq, cxi, rsq)
		if nBSV == 0 and (cbounds[0].has_key(float(gexp)) == 0 or cbounds[0][float(gexp)] > cexp):
			cbounds[0][float(gexp)] = cexp
	if dbh[3].has_key((float(cexp), float(gexp))) and dbh[4].has_key((float(cexp), float(gexp))) and dbhsv[1].has_key((float(cexp), float(gexp))):
		for i in [3, 4]:
			rate[i] = dbh[i][(float(cexp), float(gexp))]
		nBSV = dbhsv[1][(float(cexp), float(gexp))][0] - dbhsv[1][(float(cexp), float(gexp))][1]
	else:
		if dbh0[1].has_key((float(cexp), float(gexp))) == 0 or dbh[4].has_key((float(cexp), float(gexp))) == 0 or dbhsv[1].has_key((float(cexp), float(gexp))) == 0:
			param.svm_type = R2q
			model = svm_model(prob, param)
			rsq = model.rsq
			param.svm_type = C_SVCq
			model = svm_model(prob, param)
			wsq = model.wsq
			cxi = model.cxi
			if dbh0[1].has_key((float(cexp), float(gexp))) == 0:
				lf0[1].write("%s %s %s %s %s\n" % (cexp, gexp, wsq, cxi, rsq))
				lf0[1].flush()
			rate[3] = bounds[2](wsq, cxi, rsq, c)
			if dbh[3].has_key((float(cexp), float(gexp))) == 0:
				db[3].append((cexp, gexp, rate[3]))
				dbh[3][(float(cexp), float(gexp))] = rate[3]
				lf[3].write("%s %s %s\n" % (cexp, gexp, rate[3]))
				lf[3].flush()
			if dbh[4].has_key((float(cexp), float(gexp))) == 0:
				error = 0;
				for i in range(len(testy)):
					resulty = model.predict(testx[i]);
					if resulty != testy[i]:
						error += 1;
				rate[4] = float(error) / float(len(testy))
				db[4].append((cexp, gexp, rate[4]))
				dbh[4][(float(cexp), float(gexp))] = rate[4]
				lf[4].write("%s %s %s\n" % (cexp, gexp, rate[4]))
				lf[4].flush()
			if dbhsv[1].has_key((float(cexp), float(gexp))) == 0:
				nSV = 0
				nBSV = 0
				for i in range(model.nr_class):
					nSV += model.nSV[i]
					nBSV += model.nBSV[i]
				lfsv[1].write("%s %s %s %s\n" % (cexp, gexp, nSV, nSV - nBSV))
				lfsv[1].flush()
		else:
			if dbh[3].has_key((float(cexp), float(gexp))) == 0:
				wsq, cxi, rsq = dbh0[1][(float(cexp), float(gexp))]
				rate[3] = bounds[2](wsq, cxi, rsq, c)
				db[3].append((cexp, gexp, rate[3]))
				dbh[3][(cexp, gexp)] = rate[3]
				lf[3].write("%s %s %s\n" % (cexp, gexp, rate[3]))
				lf[3].flush()
			nBSV = dbhsv[1][(float(cexp), float(gexp))][0] - dbhsv[1][(float(cexp), float(gexp))][1]
		print 'wsq = %s, cxi = %s, rsq = %s' % (wsq, cxi, rsq)
#		if nBSV == 0 and (cbounds[1].has_key(float(gexp)) == 0 or cbounds[1][float(gexp)] > cexp):
#			cbounds[1][float(gexp)] = cexp
#		result = popen("nice -2 %(svmtrain)s -c %(c)s -g %(g)s -v %(fold)s -m %(mem)s %(dataset)s" % globals())
#		for line in result.readlines():
#			if find(line,"Cross") != -1:
#				rate = atof(split(line)[-1][0:-1])
#				print "%(cexp)s %(gexp)s %(rate)s" % globals()
#				db.append((cexp,gexp,rate))
	print "cexp = %(cexp)s, gexp = %(gexp)s, rates = %(rate)s," % globals()

scale_list = [0, 0, 1, 0, 1]
cbound_list = [0, 0, 0, 1, 1]

while cpass_step <= cpass_total or gpass_step <= gpass_total:
	if cpass_step/cpass_total < gpass_step/gpass_total:
		# increase C resolution
		for ci in range(0,len(cexp_seq)):
			if zerobits(ci,cpass_total) == 2**(cpass_total-cpass_step):
				for gi in range(0,len(gexp_seq)):
					if zerobits(gi,gpass_total) > 2**(gpass_total-gpass_step):
						run()
				for i in range(5):
					redraw(gnuplots[i], db[i], scale_list[i], cbounds[cbound_list[i]])
					redraw(gnuplots[i], db[i], scale_list[i], cbounds[cbound_list[i]], 1, png_file[i]) # backup
				print		
		cpass_step = cpass_step + 1
	else:
		#increase g resolution
		for gi in range(0,len(gexp_seq)):
			if zerobits(gi,gpass_total) == 2**(gpass_total-gpass_step):
				for ci in range(0,len(cexp_seq)):
					if zerobits(ci,cpass_total) > 2**(cpass_total-cpass_step):
						run()
				for i in range(5):
					redraw(gnuplots[i], db[i], scale_list[i], cbounds[cbound_list[i]])
					redraw(gnuplots[i], db[i], scale_list[i], cbounds[cbound_list[i]], 1, png_file[i]) # backup
				print
		gpass_step = gpass_step + 1
for i in range(5):
	lf[i].close()
for i in [0, 1]:
	lf0[i].close()
for i in [0, 1]:
	lfsv[i].close()
