import sys
import string
sys.path=sys.path+['.','/home/einstein/work/svm/libsvm/python']
from svm import *
from os import popen, system

# change traning data file name below
f = open("/home/einstein/work/svm/data/tree.t")
# change range of C below
cexp_begin=-10
cexp_end=10
cexp_step=0.5

labels = []
samples = []
max_index = 0
line = f.readline()
while line:
	elems = string.split(line)
	sample = {}
	for e in elems[1:]:
		points = string.split(e, ":")
		sample[int(points[0])] = float(points[1])
		if int(points[0]) > max_index:
			max_index = int(points[0])
	labels.append(float(elems[0]))
	samples.append(sample)
	line = f.readline()
f.close()
print "%d samples loaded." % (len(samples))
problem = svm_problem(labels, samples);

###################################
def gen_seq (begin,end,step):
	seq = []
	while 1:
		if step > 0 and begin > end: break
		if step < 0 and begin < end: break
		seq.append(begin)
		begin = begin + step
	return seq
##################################
gnuplot = popen("gnuplot","w")
gnuplot.write("set term png color\n")
gnuplot.write("set output \"result.png\"\n")
gnuplot.write("set xlabel \"lg(C)\"\n")
gnuplot.write("set ylabel \"RsqWsq\"\n")
gnuplot.write("set xrange [%f:%f]\n" % (cexp_begin,cexp_end))
gnuplot.write("plot \"-\" with lines lt 5\n")

param = svm_parameter(svm_type = C_SVC, kernel_type = RBF,gamma=pow(2.0,-5.0))
cexp_seq = gen_seq(cexp_begin,cexp_end,cexp_step)

for ci in range(0,len(cexp_seq)):
	param.svm_type=C_SVC
	cexp = cexp_seq[ci]
	param.C = pow(2.0,cexp)
	model1 = svm_model(problem,param)
	param.svm_type=ONE_CLASS
	model2 = svm_model(problem,param)
	gnuplot.write("%f %f\n" % (cexp_seq[ci],model1.wsq*model2.rsq))
